'use strict';

var gulp = require('gulp');
var runSequence = require('run-sequence');
var del = require('del');
var _ = require('lodash');
var path = require('path');
var $ = require('gulp-load-plugins')({
    config: path.normalize(__dirname + '/../package.json')
});

var config = {
    srcs: './src/assets/img/**',
    dest: {
        img: './build/assets/img',
        tmp: './tmp'
    }
};

function  image(options) {
    var settings = _.extend(config, options);

    var tasks = [{
        name: 'image',
        desc: 'Images optimization',
        callback: runner
    },{
        name: 'image:minify',
        callback: minify
    }];

    ////////////////

    function runner(done) {
        runSequence(
            'image:minify',
            done
        );
    }

    function minify(done) {
        return gulp.src(settings.srcs)
            .pipe($.imagemin({
              progressive: true,
              interlaced: true
            }))
            .pipe(gulp.dest(settings.dest.img))
            .pipe($.size({title: 'image:minify'}));
    }

    ////////////////

    return tasks;
}

module.exports = image;
